
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Chat_membershipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const chat_memberships = await db.chat_memberships.create(
            {
                id: data.id || undefined,
        
        member_role: data.member_role
        ||
        null
            ,
            
        joined_at: data.joined_at
        ||
        null
            ,
            
        left_at: data.left_at
        ||
        null
            ,
            
        muted: data.muted
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await chat_memberships.setChat_room( data.chat_room || null, {
            transaction,
        });
        
        await chat_memberships.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return chat_memberships;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const chat_membershipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                member_role: item.member_role
            ||
            null
            ,
            
                joined_at: item.joined_at
            ||
            null
            ,
            
                left_at: item.left_at
            ||
            null
            ,
            
                muted: item.muted
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const chat_memberships = await db.chat_memberships.bulkCreate(chat_membershipsData, { transaction });

        // For each item created, replace relation files
        

        return chat_memberships;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const chat_memberships = await db.chat_memberships.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.member_role !== undefined) updatePayload.member_role = data.member_role;
        
        
        if (data.joined_at !== undefined) updatePayload.joined_at = data.joined_at;
        
        
        if (data.left_at !== undefined) updatePayload.left_at = data.left_at;
        
        
        if (data.muted !== undefined) updatePayload.muted = data.muted;
        
        
        updatePayload.updatedById = currentUser.id;

        await chat_memberships.update(updatePayload, {transaction});

        
        
        if (data.chat_room !== undefined) {
            await chat_memberships.setChat_room(
              
              data.chat_room,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await chat_memberships.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return chat_memberships;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const chat_memberships = await db.chat_memberships.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of chat_memberships) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of chat_memberships) {
                await record.destroy({transaction});
            }
        });


        return chat_memberships;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const chat_memberships = await db.chat_memberships.findByPk(id, options);

        await chat_memberships.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await chat_memberships.destroy({
            transaction
        });

        return chat_memberships;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const chat_memberships = await db.chat_memberships.findOne(
            { where },
            { transaction },
        );

        if (!chat_memberships) {
            return chat_memberships;
        }

        const output = chat_memberships.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.chat_room = await chat_memberships.getChat_room({
            transaction
        });
        
        
        output.user = await chat_memberships.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.chat_rooms,
        as: 'chat_room',
        
        where: filter.chat_room ? {
          [Op.or]: [
            { id: { [Op.in]: filter.chat_room.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.chat_room.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.joined_atRange) {
                const [start, end] = filter.joined_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.left_atRange) {
                const [start, end] = filter.left_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    left_at: {
                    ...where.left_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    left_at: {
                    ...where.left_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.member_role) {
                where = {
                    ...where,
                member_role: filter.member_role,
            };
            }
            
            if (filter.muted) {
                where = {
                    ...where,
                muted: filter.muted,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.chat_memberships.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'chat_memberships',
                        'member_role',
                        query,
                    ),
                ],
            };
        }

        const records = await db.chat_memberships.findAll({
            attributes: [ 'id', 'member_role' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['member_role', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.member_role,
        }));
    }

    
};

